diff -r fb51f5b4aa4c trytond/pool.py
--- a/trytond/pool.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/pool.py	Mon Sep 24 20:36:36 2012 +0200
@@ -6,6 +6,17 @@
 from trytond.transaction import Transaction
 import __builtin__
 
+__all__ = ['Pool', 'PoolMeta']
+
+
+class PoolMeta(type):
+
+    def __new__(cls, name, bases, dct):
+        new = type.__new__(cls, name, bases, dct)
+        if '__name__' in dct:
+            new.__name__ = dct['__name__']
+        return new
+
 
 class Pool(object):
 
@@ -41,19 +52,17 @@
         self.database_name = database_name
 
     @staticmethod
-    def register(klass, type='model'):
+    def register(*classes, **kwargs):
         '''
-        Register a class
-
-        :param klass: the class
-        :param type: the type
+        Register a list of classes
         '''
-        module = None
-        for module in klass.__module__.split('.'):
-            if module != 'trytond' and module != 'modules':
-                break
-        if module:
-            Pool.classes[type].setdefault(module, []).append(klass)
+        module = kwargs['module']
+        type_ = kwargs['type_']
+        assert type_ in ('model', 'report', 'wizard')
+        for cls in classes:
+            mpool = Pool.classes[type_].setdefault(module, [])
+            assert cls not in mpool, cls
+            mpool.append(cls)
 
     @classmethod
     def start(cls):
@@ -61,6 +70,8 @@
         Start/restart the Pool
         '''
         with cls._lock:
+            for classes in Pool.classes.itervalues():
+                classes.clear()
             register_classes()
             cls._started = True
 
@@ -140,22 +151,17 @@
                 from trytond.report import Report
                 # Keyword argument 'type' conflicts with builtin function
                 cls = __builtin__.type(str(name), (Report,), {})
-                obj = object.__new__(cls)
-                obj._name = name
-                self.add(obj, type)
-                obj.__init__()
-                return obj
+                cls.__setup__()
+                self.add(cls, type)
+                return cls
             raise
 
-    def add(self, obj, type='model'):
+    def add(self, cls, type='model'):
         '''
-        Add an object to the pool
-
-        :param obj: the object
-        :param type: the type
+        Add a classe to the pool
         '''
         with self._locks[self.database_name]:
-            self._pool[self.database_name][type][obj._name] = obj
+            self._pool[self.database_name][type][cls.__name__] = cls
 
     def object_name_list(self, type='model'):
         '''
@@ -180,23 +186,29 @@
         '''
         return self._pool[self.database_name][type].iteritems()
 
-    def instanciate(self, module):
+    def setup(self, module):
         '''
-        Instanciate objects for a module
-
-        :param: the module name
-        :return: a dictionary with each type as key
-            and a list of object as value
+        Setup classes for module and return a list of classes for each type in
+        a dictionary.
         '''
-        res = {}
-        for _type in self.classes.keys():
-            res[_type] = []
-            for cls in self.classes[_type].get(module, []):
-                if cls._name in self._pool[self.database_name][_type].keys():
-                    parent_cls = self.get(cls._name, type=_type).__class__
-                    cls = type(cls._name, (cls, parent_cls), {})
-                obj = object.__new__(cls)
-                self.add(obj, type=_type)
-                obj.__init__()
-                res[_type].append(obj)
-        return res
+        classes = {}
+        for type_ in self.classes.keys():
+            classes[type_] = []
+            for cls in self.classes[type_].get(module, []):
+                try:
+                    previous_cls = self.get(cls.__name__, type=type_)
+                    cls = type(cls.__name__, (cls, previous_cls), {})
+                except KeyError:
+                    pass
+                try:
+                    cls.__setup__()
+                except AttributeError:
+                    if issubclass(cls.__class__, PoolMeta):
+                        continue
+                    raise
+                self.add(cls, type=type_)
+                classes[type_].append(cls)
+            for cls in classes[type_]:
+                if hasattr(cls, '__post_setup__'):
+                    cls.__post_setup__()
+        return classes
diff -r fb51f5b4aa4c trytond/protocols/dispatcher.py
--- a/trytond/protocols/dispatcher.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/protocols/dispatcher.py	Mon Sep 24 20:36:36 2012 +0200
@@ -20,10 +20,11 @@
 from trytond.cache import Cache
 from trytond.exceptions import UserError, UserWarning, NotLogged, \
     ConcurrencyException
+from trytond.rpc import RPC
 
 
 def dispatch(host, port, protocol, database_name, user, session, object_type,
-        object_name, method, *args, **kargs):
+        object_name, method, *args, **kwargs):
 
     if object_type == 'common':
         if method == 'login':
@@ -68,7 +69,7 @@
             ]
         elif method == 'db_exist':
             try:
-                database = Database(*args, **kargs).connect()
+                database = Database(*args, **kwargs).connect()
                 cursor = database.cursor()
                 cursor.close(close=True)
                 return True
@@ -88,13 +89,13 @@
                 res = []
             return res
         elif method == 'create':
-            return create(*args, **kargs)
+            return create(*args, **kwargs)
         elif method == 'restore':
-            return restore(*args, **kargs)
+            return restore(*args, **kwargs)
         elif method == 'drop':
-            return drop(*args, **kargs)
+            return drop(*args, **kwargs)
         elif method == 'dump':
-            return dump(*args, **kargs)
+            return dump(*args, **kwargs)
         return
     elif object_type == 'system':
         database = Database(database_name).connect()
@@ -131,34 +132,36 @@
             pool.init()
     obj = pool.get(object_name, type=object_type)
 
-    if method in obj._rpc:
-        readonly = not obj._rpc[method]
+    if method in obj.__rpc__:
+        rpc = obj.__rpc__[method]
     elif method in getattr(obj, '_buttons', {}):
-        readonly = False
+        rpc = RPC(readonly=False, instantiate=0)
     else:
         raise UserError('Calling method %s on %s %s is not allowed!'
             % (method, object_type, object_name))
 
     for count in range(int(CONFIG['retry']), -1, -1):
         with Transaction().start(database_name, user,
-                readonly=readonly) as transaction:
+                readonly=rpc.readonly) as transaction:
             try:
-
-                args_without_context = list(args)
-                if 'context' in kargs:
-                    context = kargs.pop('context')
+                args, kwargs, transaction.context, transaction.timestamp = \
+                    rpc.convert(obj, *args, **kwargs)
+                meth = getattr(obj, method)
+                if not hasattr(meth, 'im_self') or meth.im_self:
+                    result = rpc.result(meth(*args, **kwargs))
                 else:
-                    context = args_without_context.pop()
-                if '_timestamp' in context:
-                    transaction.timestamp = context['_timestamp']
-                    del context['_timestamp']
-                transaction.context = context
-                res = getattr(obj, method)(*args_without_context, **kargs)
-                if not readonly:
+                    assert rpc.instantiate == 0
+                    inst = args.pop(0)
+                    if hasattr(inst, method):
+                        result = rpc.result(meth(inst, *args, **kwargs))
+                    else:
+                        result = [rpc.result(meth(i, *args, **kwargs))
+                            for i in inst]
+                if not rpc.readonly:
                     transaction.cursor.commit()
             except DatabaseOperationalError, exception:
                 transaction.cursor.rollback()
-                if count and not readonly:
+                if count and not rpc.readonly:
                     continue
                 raise
             except Exception, exception:
@@ -176,16 +179,16 @@
         if not (object_name == 'res.request' and method == 'request_get'):
             with Transaction().start(database_name, 0) as transaction:
                 pool = Pool(database_name)
-                session_obj = pool.get('ir.session')
+                Session = pool.get('ir.session')
                 try:
-                    session_obj.reset(session)
+                    Session.reset(session)
                 except DatabaseOperationalError:
                     # Silently fail when reseting session
                     transaction.cursor.rollback()
                 else:
                     transaction.cursor.commit()
         Cache.resets(database_name)
-        return res
+        return result
 
 
 def create(database_name, password, lang, admin_password):
@@ -237,9 +240,9 @@
             cursor.execute('UPDATE res_user ' \
                     'SET password = %s ' \
                     'WHERE login = \'admin\'', (admin_password,))
-            module_obj = pool.get('ir.module.module')
-            if module_obj:
-                module_obj.update_list()
+            Module = pool.get('ir.module.module')
+            if Module:
+                Module.update_list()
             cursor.commit()
             res = True
     except Exception:
diff -r fb51f5b4aa4c trytond/protocols/webdav.py
--- a/trytond/protocols/webdav.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/protocols/webdav.py	Mon Sep 24 20:36:36 2012 +0200
@@ -174,12 +174,12 @@
             return res
         pool = Pool(Transaction().cursor.database_name)
         try:
-            collection_obj = pool.get('webdav.collection')
+            Collection = pool.get('webdav.collection')
             scheme, netloc, path, params, query, fragment = \
                 urlparse.urlparse(uri)
             if path[-1:] != '/':
                 path += '/'
-            for child in collection_obj.get_childs(dburi, filter=filter,
+            for child in Collection.get_childs(dburi, filter=filter,
                     cache=CACHE):
                 res.append(urlparse.urlunparse((scheme, netloc,
                             path + child.encode('utf-8'), params, query,
@@ -230,9 +230,9 @@
             res += '</html>'
             return res
         pool = Pool(Transaction().cursor.database_name)
-        collection_obj = pool.get('webdav.collection')
+        Collection = pool.get('webdav.collection')
         try:
-            res = collection_obj.get_data(dburi, cache=CACHE)
+            res = Collection.get_data(dburi, cache=CACHE)
         except (DAV_Error, DAV_NotFound, DAV_Secret, DAV_Forbidden), exception:
             self._log_exception(exception)
             raise
@@ -261,9 +261,9 @@
         if not dbname or not dburi:
             raise DAV_Forbidden
         pool = Pool(Transaction().cursor.database_name)
-        collection_obj = pool.get('webdav.collection')
+        Collection = pool.get('webdav.collection')
         try:
-            res = collection_obj.put(dburi, data, content_type, cache=CACHE)
+            res = Collection.put(dburi, data, content_type, cache=CACHE)
             Transaction().cursor.commit()
         except (DAV_Error, DAV_NotFound, DAV_Secret, DAV_Forbidden), exception:
             self._log_exception(exception)
@@ -284,9 +284,9 @@
         if not dbname or not dburi:
             raise DAV_Forbidden
         pool = Pool(Transaction().cursor.database_name)
-        collection_obj = pool.get('webdav.collection')
+        Collection = pool.get('webdav.collection')
         try:
-            res = collection_obj.mkcol(dburi, cache=CACHE)
+            res = Collection.mkcol(dburi, cache=CACHE)
             Transaction().cursor.commit()
         except (DAV_Error, DAV_NotFound, DAV_Secret, DAV_Forbidden), exception:
             self._log_exception(exception)
@@ -303,9 +303,9 @@
         if not dbname or not dburi:
             return COLLECTION
         pool = Pool(Transaction().cursor.database_name)
-        collection_obj = pool.get('webdav.collection')
+        Collection = pool.get('webdav.collection')
         try:
-            res = collection_obj.get_resourcetype(dburi, cache=CACHE)
+            res = Collection.get_resourcetype(dburi, cache=CACHE)
         except (DAV_Error, DAV_NotFound, DAV_Secret, DAV_Forbidden), exception:
             self._log_exception(exception)
             raise
@@ -320,8 +320,8 @@
             return uri.split('/')[-1]
         pool = Pool(Transaction().cursor.database_name)
         try:
-            collection_obj = pool.get('webdav.collection')
-            res = collection_obj.get_displayname(dburi, cache=CACHE)
+            Collection = pool.get('webdav.collection')
+            res = Collection.get_displayname(dburi, cache=CACHE)
         except KeyError:
             raise DAV_NotFound
         except (DAV_Error, DAV_NotFound, DAV_Secret, DAV_Forbidden), exception:
@@ -337,9 +337,9 @@
         if not dbname or not dburi:
             return '0'
         pool = Pool(Transaction().cursor.database_name)
-        collection_obj = pool.get('webdav.collection')
+        Collection = pool.get('webdav.collection')
         try:
-            res = collection_obj.get_contentlength(dburi, cache=CACHE)
+            res = Collection.get_contentlength(dburi, cache=CACHE)
         except (DAV_Error, DAV_NotFound, DAV_Secret, DAV_Forbidden), exception:
             self._log_exception(exception)
             raise
@@ -353,9 +353,9 @@
         if not dbname or self.is_collection(uri):
             return "text/html"
         pool = Pool(Transaction().cursor.database_name)
-        collection_obj = pool.get('webdav.collection')
+        Collection = pool.get('webdav.collection')
         try:
-            res = collection_obj.get_contenttype(dburi, cache=CACHE)
+            res = Collection.get_contenttype(dburi, cache=CACHE)
         except (DAV_Error, DAV_NotFound, DAV_Secret, DAV_Forbidden), exception:
             self._log_exception(exception)
             raise
@@ -372,9 +372,9 @@
         if not dbname or not dburi:
             return time.time()
         pool = Pool(Transaction().cursor.database_name)
-        collection_obj = pool.get('webdav.collection')
+        Collection = pool.get('webdav.collection')
         try:
-            res = collection_obj.get_creationdate(dburi, cache=CACHE)
+            res = Collection.get_creationdate(dburi, cache=CACHE)
         except (DAV_Error, DAV_NotFound, DAV_Secret, DAV_Forbidden), exception:
             self._log_exception(exception)
             raise
@@ -388,9 +388,9 @@
         if not dbname or not dburi:
             return time.time()
         pool = Pool(Transaction().cursor.database_name)
-        collection_obj = pool.get('webdav.collection')
+        Collection = pool.get('webdav.collection')
         try:
-            res = collection_obj.get_lastmodified(dburi, cache=CACHE)
+            res = Collection.get_lastmodified(dburi, cache=CACHE)
         except (DAV_Error, DAV_NotFound, DAV_Secret, DAV_Forbidden), exception:
             self._log_exception(exception)
             raise
@@ -404,9 +404,9 @@
         if not dbname or not dburi:
             return 403
         pool = Pool(Transaction().cursor.database_name)
-        collection_obj = pool.get('webdav.collection')
+        Collection = pool.get('webdav.collection')
         try:
-            res = collection_obj.rmcol(dburi, cache=CACHE)
+            res = Collection.rmcol(dburi, cache=CACHE)
             Transaction().cursor.commit()
         except Exception, exception:
             self._log_exception(exception)
@@ -419,9 +419,9 @@
         if not dbname or not dburi:
             return 403
         pool = Pool(Transaction().cursor.database_name)
-        collection_obj = pool.get('webdav.collection')
+        Collection = pool.get('webdav.collection')
         try:
-            res = collection_obj.rm(dburi, cache=CACHE)
+            res = Collection.rm(dburi, cache=CACHE)
             Transaction().cursor.commit()
         except Exception, exception:
             self._log_exception(exception)
@@ -434,9 +434,9 @@
         if not dbname or not dburi:
             return 1
         pool = Pool(Transaction().cursor.database_name)
-        collection_obj = pool.get('webdav.collection')
+        Collection = pool.get('webdav.collection')
         try:
-            res = collection_obj.exists(dburi, cache=CACHE)
+            res = Collection.exists(dburi, cache=CACHE)
         except (DAV_Error, DAV_NotFound, DAV_Secret, DAV_Forbidden), exception:
             self._log_exception(exception)
             raise
@@ -485,8 +485,8 @@
         else:
             pool = Pool(Transaction().cursor.database_name)
             try:
-                collection_obj = pool.get('webdav.collection')
-                privileges = collection_obj.current_user_privilege_set(dburi,
+                Collection = pool.get('webdav.collection')
+                privileges = Collection.current_user_privilege_set(dburi,
                         cache=CACHE)
             except KeyError:
                 pass
@@ -579,8 +579,8 @@
                     pool = Pool(dbname)
                     if not dbname in database_list:
                         pool.init()
-                    share_obj = pool.get('webdav.share')
-                    user = share_obj.get_login(key, command, path)
+                    Share = pool.get('webdav.share')
+                    user = Share.get_login(key, command, path)
                     transaction.cursor.commit()
             if not user:
                 return None
diff -r fb51f5b4aa4c trytond/pyson.py
--- a/trytond/pyson.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/pyson.py	Mon Sep 24 20:36:36 2012 +0200
@@ -547,8 +547,8 @@
 
     def pyson(self):
         from trytond.pool import Pool
-        model_data_obj = Pool().get('ir.model.data')
-        return model_data_obj.get_id(self._module, self._fs_id)
+        ModelData = Pool().get('ir.model.data')
+        return ModelData.get_id(self._module, self._fs_id)
 
     def types(self):
         return set([int])
diff -r fb51f5b4aa4c trytond/report/report.py
--- a/trytond/report/report.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/report/report.py	Mon Sep 24 20:36:36 2012 +0200
@@ -22,9 +22,10 @@
 from genshi.filters import Translator
 import lxml.etree
 from trytond.config import CONFIG
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 from trytond.transaction import Transaction
 from trytond.url import URLMixin
+from trytond.rpc import RPC
 
 MIMETYPES = {
     'odt': 'application/vnd.oasis.opendocument.text',
@@ -55,9 +56,10 @@
 
 class ReportFactory:
 
-    def __call__(self, objects, **kwargs):
+    def __call__(self, records, **kwargs):
         data = {}
-        data['objects'] = objects
+        data['objects'] = records  # XXX To remove
+        data['records'] = records
         data.update(kwargs)
         return data
 
@@ -73,7 +75,7 @@
     def __call__(self, text):
         if self.language not in self.cache:
             self.cache[self.language] = {}
-            translation_ids = self.translation.search([
+            translations = self.translation.search([
                 ('lang', '=', self.language),
                 ('type', '=', 'odt'),
                 ('name', '=', self.report_name),
@@ -82,7 +84,7 @@
                 ('fuzzy', '=', False),
                 ('res_id', '=', None),
                 ])
-            for translation in self.translation.browse(translation_ids):
+            for translation in translations:
                 self.cache[self.language][translation.src] = translation.value
         return self.cache[self.language].get(text, text)
 
@@ -91,78 +93,92 @@
 
 
 class Report(URLMixin):
-    _name = ""
+    __metaclass__ = PoolMeta
 
-    def __new__(cls):
-        Pool.register(cls, type='report')
+    @classmethod
+    def __setup__(cls):
+        cls.__rpc__ = {
+            'execute': RPC(),
+            }
 
-    def __init__(self):
-        self._rpc = {
-            'execute': False,
-        }
-
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         pass
 
-    def execute(self, ids, datas):
+    @classmethod
+    def execute(cls, ids, data):
         '''
-        Execute the report.
-
-        :param ids: a list of record ids on which execute report
-        :param datas: a dictionary with datas that will be set in
-            local context of the report
-        :return: a tuple with:
+        Execute the report on record ids.
+        The dictionary with data that will be set in local context of the
+        report.
+        It returns a tuple with:
             report type,
             data,
             a boolean to direct print,
             the report name
         '''
         pool = Pool()
-        action_report_obj = pool.get('ir.action.report')
-        action_report_ids = action_report_obj.search([
-            ('report_name', '=', self._name)
-            ])
-        if not action_report_ids:
-            raise Exception('Error', 'Report (%s) not find!' % self._name)
-        action_report = action_report_obj.browse(action_report_ids[0])
-        objects = None
+        ActionReport = pool.get('ir.action.report')
+        action_reports = ActionReport.search([
+                ('report_name', '=', cls.__name__)
+                ])
+        if not action_reports:
+            raise Exception('Error', 'Report (%s) not find!' % cls.__name__)
+        action_report = action_reports[0]
+        records = None
         if action_report.model:
-            objects = self._get_objects(ids, action_report.model, datas)
-        type, data = self.parse(action_report, objects, datas, {})
+            records = cls._get_records(ids, action_report.model, data)
+        type, data = cls.parse(action_report, records, data, {})
         return (type, buffer(data), action_report.direct_print,
-                action_report.name)
+            action_report.name)
 
-    def _get_objects(self, ids, model, datas):
+    @classmethod
+    def _get_records(cls, ids, model, data):
         pool = Pool()
-        model_obj = pool.get(model)
-        return model_obj.browse(ids)
+        Model = pool.get(model)
 
-    def parse(self, report, objects, datas, localcontext):
+        class TranslateModel:
+            _languages = {}
+
+            def __init__(self, id):
+                self.id = id
+                self._language = Transaction().language
+
+            def setLang(self, language):
+                self._language = language
+
+            def __getattr__(self, name):
+                if self._language not in TranslateModel._languages:
+                    with Transaction().set_context(language=self._language):
+                        records = Model.browse(ids)
+                    id2record = dict((r.id, r) for r in records)
+                    TranslateModel._languages[self._language] = id2record
+                else:
+                    id2record = TranslateModel._languages[self._language]
+                record = id2record[self.id]
+                return getattr(record, name)
+        return [TranslateModel(id) for id in ids]
+
+    @classmethod
+    def parse(cls, report, records, data, localcontext):
         '''
-        Parse the report.
-
-        :param report: a BrowseRecord of the ir.action.report
-        :param objects: a BrowseRecordList of the records on which parse report
-        :param datas: a dictionary with datas that will be set in local context
-            of the report
-        :param localcontext: the context used to parse the report
-        :return: a tuple with:
-            report type
-            report
+        Parse the report and return a tuple with report type and report.
         '''
         pool = Pool()
-        localcontext['datas'] = datas
-        localcontext['user'] = pool.get('res.user'
-                ).browse(Transaction().user)
+        User = pool.get('res.user')
+        Translation = pool.get('ir.translation')
+
+        localcontext['data'] = data
+        localcontext['user'] = User(Transaction().user)
         localcontext['formatLang'] = lambda *args, **kargs: \
-                self.format_lang(*args, **kargs)
+            cls.format_lang(*args, **kargs)
         localcontext['StringIO'] = StringIO.StringIO
         localcontext['time'] = time
         localcontext['datetime'] = datetime
         localcontext['context'] = Transaction().context
 
-        translate = TranslateFactory(self._name, Transaction().language,
-                pool.get('ir.translation'))
+        translate = TranslateFactory(cls.__name__, Transaction().language,
+            Translation)
         localcontext['setLang'] = lambda language: translate.set_language(
             language)
 
@@ -257,9 +273,10 @@
             localcontext.iteritems()))
         #Test compatibility with old relatorio version <= 0.3.0
         if len(inspect.getargspec(rel_report.__call__)[0]) == 2:
-            data = rel_report(objects, **localcontext).render().getvalue()
+            data = rel_report(records, **localcontext).render().getvalue()
         else:
-            localcontext['objects'] = objects
+            localcontext['objects'] = records  # XXX to remove
+            localcontext['records'] = records
             data = rel_report(**localcontext).render()
             if hasattr(data, 'getvalue'):
                 data = data.getvalue()
@@ -267,11 +284,12 @@
         os.remove(path)
         output_format = report.extension or report.template_extension
         if output_format not in MIMETYPES:
-            data = self.unoconv(data, report.template_extension, output_format)
+            data = cls.unoconv(data, report.template_extension, output_format)
         oext = FORMAT2EXT.get(output_format, output_format)
         return (oext, data)
 
-    def unoconv(self, data, input_format, output_format):
+    @classmethod
+    def unoconv(cls, data, input_format, output_format):
         '''
         Call unoconv to convert the OpenDocument
         '''
@@ -291,17 +309,18 @@
         finally:
             os.remove(path)
 
-    def format_lang(self, value, lang, digits=2, grouping=True, monetary=False,
+    @classmethod
+    def format_lang(cls, value, lang, digits=2, grouping=True, monetary=False,
             date=False, currency=None, symbol=True):
         pool = Pool()
-        lang_obj = pool.get('ir.lang')
+        Lang = pool.get('ir.lang')
 
         if date:
             if lang:
                 locale_format = lang.date
                 code = lang.code
             else:
-                locale_format = lang_obj.default_date()
+                locale_format = Lang.default_date()
                 code = CONFIG['language']
             if not isinstance(value, time.struct_time):
                 # assume string, parse it
@@ -318,9 +337,9 @@
                     string_pattern)[:6])
             else:
                 date = datetime.datetime(*(value.timetuple()[:6]))
-            return lang_obj.strftime(date, code, locale_format)
+            return Lang.strftime(date, code, locale_format)
         if currency:
-            return lang_obj.currency(lang, value, currency, grouping=grouping,
-                    symbol=symbol)
-        return lang_obj.format(lang, '%.' + str(digits) + 'f', value,
-                grouping=grouping, monetary=monetary)
+            return Lang.currency(lang, value, currency, grouping=grouping,
+                symbol=symbol)
+        return Lang.format(lang, '%.' + str(digits) + 'f', value,
+            grouping=grouping, monetary=monetary)
diff -r fb51f5b4aa4c trytond/res/__init__.py
--- a/trytond/res/__init__.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/res/__init__.py	Mon Sep 24 20:36:36 2012 +0200
@@ -1,6 +1,38 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
+from ..pool import Pool
 from .group import *
 from .user import *
 from .request import *
 from .ir import *
+
+
+def register():
+    Pool.register(
+        Group,
+        User,
+        Group2,
+        UserAction,
+        UserGroup,
+        Warning_,
+        UserConfigStart,
+        Request,
+        RequestLink,
+        RequestHistory,
+        RequestReference,
+        UIMenuGroup,
+        ActionGroup,
+        ModelFieldGroup,
+        ModelButtonGroup,
+        RuleGroupGroup,
+        RuleGroupUser,
+        Lang,
+        SequenceType,
+        SequenceTypeGroup,
+        Sequence,
+        SequenceStrict,
+        ModuleConfigWizardItem,
+        module='res', type_='model')
+    Pool.register(
+        UserConfig,
+        module="res", type_='wizard')
